package com.engine.fssecond.web;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.fssecond.service.EleEctronVoucherService;
import com.engine.fssecond.service.impl.EleEctronVoucherServiceImpl;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2025/4/9 14:46
 * @Description:
 * @Version 1.0
 */
public class EleEctronVoucherAction {

    private EleEctronVoucherService getService(User user) {
        return  ServiceUtil.getService(EleEctronVoucherServiceImpl.class, user);
    }


    @GET
    @Path("/generateFile")
    @Produces(MediaType.TEXT_PLAIN)
    public String generateFile(@Context HttpServletRequest request, @Context HttpServletResponse response,
                               @QueryParam("billId") String billId,@QueryParam("host") String host){
        Map<String, Object> data = new HashMap<>(8);
        try {
            User user = HrmUserVarify.getUser(request, response);
            Map<String, Object> params = ParamUtil.request2Map(request);
            data.putAll(getService(user).generateFile(params));
        } catch (Exception e) {
            data.put("msg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(data, SerializerFeature.DisableCircularReferenceDetect);
    }
}
